//+------------------------------------------------------------------+
//|                                                 VininI_Level.mq4 |
//|                                Copyright  2009, Victor Nicolaev |
//|                                                    vinin.ucoz.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Victor Nicolaev"
#property link      "vinin.ucoz.ru"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue

extern int CountBar     =24;


double LRMA[], UP[], DN[], tmp1[], tmp2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
   SetIndexBuffer(0,LRMA);
   SetIndexBuffer(1,UP);
   SetIndexBuffer(2,DN);
   SetIndexBuffer(3,tmp1);
   SetIndexBuffer(4,tmp2);
   SetIndexStyle(0,DRAW_LINE);
   
   SetIndexDrawBegin(0,CountBar);
   IndicatorShortName("AMA("+CountBar+")"); 
   SetIndexLabel(0,"AMA");



   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i, counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;

   if (limit>CountBar) limit-=CountBar;
   for (i=limit;i>0;i--) {
      tmp1[i]=3.0*iMA(Symbol(),0,CountBar,0,MODE_LWMA,PRICE_CLOSE,i)-2.0*iMA(Symbol(),0,CountBar,0,MODE_SMA,PRICE_MEDIAN,i);
      UP[i]=MathMax(High[i]-tmp1[i],0.0);
      DN[i]=MathMax(tmp1[i]-Low[i],0.0);
   }
   for (i=limit;i>0;i--) 
      tmp2[i]=tmp1[i]+iMAOnArray(UP,0,CountBar,0,MODE_EMA,i)-iMAOnArray(DN,0,CountBar,0,MODE_EMA,i);
   for (i=limit;i>0;i--)       
      LRMA[i]=iMAOnArray(tmp2,0,3,0,MODE_EMA,i);

   return(0);
  }
//+------------------------------------------------------------------+

